# Textadept

- Home |
- Download |
- Book |
- Manual |
- API |
- Source |
- Language Modules |
- Stats |
- Wiki |
- Mailing List

# Changelog

Atom Feed

Please donate or purchase the book to fund continuous development.

## 7.9 (11 Mar 2015)

Download:

- Textadept 7.9 – Win32
- Textadept 7.9 – Mac OSX Intel 10.5+
- Textadept 7.9 – Linux
- Textadept 7.9 – Linux x86_64
- Textadept 7.9 – Modules

Bugfixes:

- Fixed command entry’s abbreviated environment to allow functions to return values.
- Fixed accidental firing of “Escape” key on window focus lost.
- Fixed tab stop calculation in the terminal version.

Changes:

- The following view-specific properties are now considered buffer-specific: “view EOL”, “view whitespace”, “wrap mode”, “margin type”, and “margin width”; updated the “Buffer” and “View” menus appropriately.
- Officially supported language modules moved to a new repository.
- Added Fish lexer.
- Merged `events.FILE_SAVED_AS` into `events.FILE_AFTER_SAVE` as a new parameter.
- Merged `textadept.file_types.shebangs` into `textadept.file_types.patterns`.
- Removed `io.boms`.
- Updated to Scintilla 3.5.4.

## 7.8 (01 Feb 2015)

Download:

- Textadept 7.8 – Win32
- Textadept 7.8 – Mac OSX Intel 10.5+
- Textadept 7.8 – Linux
- Textadept 7.8 – Linux x86_64
- Textadept 7.8 – Modules

Bugfixes:

- Fixed snippets bug where name matches lexer name.

Changes:

- Removed language-specific context menus; manipulate `textadept.menu.context_menu` directly from language modules.

## 7.8 beta 3 (21 Jan 2015)

Download:

- Textadept 7.8 beta 3 – Win32
- Textadept 7.8 beta 3 – Mac OSX Intel 10.5+
- Textadept 7.8 beta 3 – Linux
- Textadept 7.8 beta 3 – Linux x86_64
- Textadept 7.8 beta 3 – Modules

Bugfixes:

- Fixed opening files with network paths on Win32.
- Fixed minor GTK 3 issues.
- Fixed bug in hiding caret when Textadept loses focus.

Changes:

- Restore `^Z` key binding as “undo” if terminal suspend is disabled.
- Added `events.SUSPEND` and `events.RESUME` events for terminal suspend and resume.
- Updated to Scintilla 3.5.3.

## 7.8 beta 2 (11 Jan 2015)

Download:

- Textadept 7.8 beta 2 – Win32
- Textadept 7.8 beta 2 – Mac OSX Intel 10.5+
- Textadept 7.8 beta 2 – Linux
- Textadept 7.8 beta 2 – Linux x86_64
- Textadept 7.8 beta 2 – Modules

Bugfixes:

- Improved C module’s ctags lookups and autocompletion.
- Do not select a line when clicking on its first character in the terminal version.
- Fixed some cases of toggling find options via API in the terminal version.

Changes:

- The terminal version can suspend via `^Z` (changed “undo” key binding to `M-Z` and added additional `M-S-Z` “redo” binding).
- Added `spawn_proc:close()` for sending EOF to spawned processes.
- Updated to Scintilla 3.5.2.

## 7.8 beta (01 Dec 2014)

Download:

- Textadept 7.8 beta – Win32
- Textadept 7.8 beta – Mac OSX Intel 10.5+
- Textadept 7.8 beta – Linux
- Textadept 7.8 beta – Linux x86_64
- Textadept 7.8 beta – Modules

Bugfixes:

- Fixed extra space pasting from external Win32 apps.
- Fixed bug in C autocompletion.
- Disable GCC optimizations when compiling with debug symbols.
- Ensure “find in files” is off when activating normal find.
- Fixed return values from `ui.dialogs.optionselect()`.
- The command entry does not hide when the window loses focus.
- Fixed ‘//’ bug when iterating over root directory with `lfs.dir_foreach()`.
- Fixed bug in jumping to compile/run errors and clear annotations before building projects.

Changes:

- Replaced the command entry text field with a Scintilla buffer and added `ui.command_entry.editing_keys` for changing the editing keys in all modes.
- Added lexer and height parameters to `ui.command_entry.enter_mode()`.
- Support bracketed paste in the terminal version.
- Allow handling of unknown CSI events.
- Added mouse support for buffers and eliminated many curses incompatibilities.
- Added `_G.LINUX` and `_G.BSD` platform flags for the sake of completeness.
- Rectangular selections with the mouse on Linux use the `Alt` modifier key instead of `Super`.
- Display the current working directory in fileselect dialogs.
- Added `_SCINTILLA.next_image_type()` for registering images.
- Added Arabic translation.
- File dialogs in the terminal span the whole view.
- Added basic UTF-8 support for terminal widgets – locales such as Russian now display properly.
- Added UTF-8 input mode for Mac OSX (`⌘⇧U`) and the terminal version (`M-U`).
- Show character information in “Show Style” popup.

## 7.7 (01 Oct 2014)

Download:

- Textadept 7.7 – Win32
- Textadept 7.7 – Mac OSX Intel 10.5+
- Textadept 7.7 – Linux
- Textadept 7.7 – Linux x86_64
- Textadept 7.7 – Modules

Bugfixes:

- Fixed corner-case in switching to most recent buffer after closing.
- Fixed find/replace bug when embedded Lua code evaluates to a number.

Changes:

- Mac OSX GUI version can truly `spawn()` processes now.
- Updated to Scintilla 3.5.1.

## 7.6 (01 Sep 2014)

Download:

- Textadept 7.6 – Win32
- Textadept 7.6 – Mac OSX Intel 10.5+
- Textadept 7.6 – Linux
- Textadept 7.6 – Linux x86_64
- Textadept 7.6 – Modules

Bugfixes:

- Recognize DEL when emitted by the Backspace key in the terminal version.

Changes:

- Terminal version can truly `spawn()` processes now.
- Added Linux .desktop files for menus and launchers.
- Indicate presence of a BOM in the statusbar.
- Switch to previous buffer after closing a buffer.
- More options for `lfs.dir_foreach()`.
- Updated to Scintilla 3.5.0.

## 7.5 (11 Jul 2014)

Download:

- Textadept 7.5 – Win32
- Textadept 7.5 – Mac OSX Intel 10.5+
- Textadept 7.5 – Linux
- Textadept 7.5 – Linux x86_64
- Textadept 7.5 – Modules

Bugfixes:

- None.

Changes:

- New events.FOCUS event for when Textadept’s window receives focus.
- Condensed manual and API documentation into single files.
- Added Polish translation.
- Updated to Scintilla 3.4.4.

## 7.4 (11 Jun 2014)

Download:

- Textadept 7.4 – Win32
- Textadept 7.4 – Mac OSX Intel 10.5+
- Textadept 7.4 – Linux
- Textadept 7.4 – Linux x86_64
- Textadept 7.4 – Modules

Bugfixes:

- Fix crash in Windows with sending input to spawned processes.
- Fix compile, run, and build command output with split views.
- Fix `#RRGGBB` color interpretation for styles.
- Fix word autocompletion when ignoring case.

Changes:

- Pressing the Enter key in the message buffer and find in files buffer simulates a double-click.

## 7.3 (01 Jun 2014)

Download:

- Textadept 7.3 – Win32
- Textadept 7.3 – Mac OSX Intel 10.5+
- Textadept 7.3 – Linux
- Textadept 7.3 – Linux x86_64
- Textadept 7.3 – Modules

Bugfixes:

- Export Lua symbols correctly on Windows.
- Fixed occasional bug when double-clicking in the message buffer.
- Fixed an edge-case in word highlighting.

Changes:

- Added reST and YAML lexers and official language modules for each.
- Use `spawn()` for launching help.
- Renamed `io.set_buffer_encoding()` to `buffer:set_encoding()`.
- Removed Adeptsense in favor of autocompleter functions, but kept existing api file format.
- Renamed `textadept.editing.autocomplete_word()` to `textadept.editing.autocomplete``('word')`.
- New `textadept.editing.AUTOCOMPLETE_ALL` field for autocompleting words from all open buffers.
- Dropped support for official java, php, rails, and rhtml modules; they are on the wiki now.
- Removed `textadept.editing.HIGHLIGHT_BRACES` option, as indicator style can be changed to hide highlighting.
- Removed `textadept.editing.select_indented_block()`.
- In-place menu editing via `textadept.menu.menubar`, `textadept.menu.context_menu`, and `textadept.menu.tab_context_menu` tables.
- Removed `textadept.command_entry.complete_lua()` and `textadept.command_entry.execute_lua()` and moved their key bindings into their module.
- Updated to Scintilla 3.4.2.

## 7.2 (01 May 2014)

Download:

- Textadept 7.2 – Win32
- Textadept 7.2 – Mac OSX Intel 10.5+
- Textadept 7.2 – Linux
- Textadept 7.2 – Linux x86_64
- Textadept 7.2 – Modules

Bugfixes:

- None.

Changes:

- Message buffer can send input to spawned processes.

## 7.2 beta 4 (11 Apr 2014)

Download:

- Textadept 7.2 beta 4 – Win32
- Textadept 7.2 beta 4 – Mac OSX Intel 10.5+
- Textadept 7.2 beta 4 – Linux
- Textadept 7.2 beta 4 – Linux x86_64
- Textadept 7.2 beta 4 – Modules

Bugfixes:

- Fixed bug in parsing output from a cancelled dropdown dialog.
- Always use absolute file paths so sessions are saved and reloaded properly.
- Temporarily disabled asynchronous spawning on OSX due to GLib crashes.

Changes:

- None.

## 7.2 beta 3 (01 Apr 2014)

Download:

- Textadept 7.2 beta 3 – Win32
- Textadept 7.2 beta 3 – Mac OSX Intel 10.5+
- Textadept 7.2 beta 3 – Linux
- Textadept 7.2 beta 3 – Linux x86_64
- Textadept 7.2 beta 3 – Modules

Bugfixes:

- Fixed bug in Win32 terminal version with “shifted” character input.

Changes:

- New optionselect dialog.
- Added `ui.SILENT_PRINT` option for printing messages.
- The GUI version can spawn processes in separate threads.
- Removed experimental Windows `io.popen()` and `os.execute()` replacements due to spawning support.
- Snapopen now supports projects; added new menu entry and key command.
- Added support for building projects.
- Updated to LuaJIT 2.0.3.
- Updated to Scintilla 3.4.1.

## 7.2 beta 2 (01 Mar 2014)

Download:

- Textadept 7.2 beta 2 – Win32
- Textadept 7.2 beta 2 – Mac OSX Intel 10.5+
- Textadept 7.2 beta 2 – Linux
- Textadept 7.2 beta 2 – Linux x86_64
- Textadept 7.2 beta 2 – Modules

Bugfixes:

- Fixed bug with empty entries in multiple entry inputboxes.

Changes:

- Terminal version now has split views along with key bindings for them.

## 7.2 beta (11 Feb 2014)

Download:

- Textadept 7.2 beta – Win32
- Textadept 7.2 beta – Mac OSX Intel 10.5+
- Textadept 7.2 beta – Linux
- Textadept 7.2 beta – Linux x86_64
- Textadept 7.2 beta – Modules

Bugfixes:

- Handle ./ and ../ sequences in filepaths.
- Correctly restore views with word wrap enabled.

Changes:

- Added Swedish translation.
- Added support for multiple entry boxes in inputdialogs.
- Updated to Scintilla 3.3.9.

## 7.2 alpha (01 Jan 2014)

Download:

- Textadept 7.2 alpha – Win32
- Textadept 7.2 alpha – Mac OSX Intel 10.5+
- Textadept 7.2 alpha – Linux
- Textadept 7.2 alpha – Linux x86_64
- Textadept 7.2 alpha – Modules

Bugfixes:

- Honor `ui.maximized` setting in session files.
- Do not halt opening files if one of them is already open.
- Better key input handling in the terminal version.
- Fixed Makefile bug in grabbing dependencies with older versions of wget.
- Recognize lower-case drive letter names for files passed from external programs in Windows.

Changes:

- Added Dart lexer.
- Do not split the view when printing messages if tabs are enabled.
- Look for ~/.textadept/osx_env.sh for OSX environment variables due to changes in Mac OSX 10.9.
- [Experimental] Replaced Lua’s `io.popen()` and `os.execute()` with versions that do not flash the “black box” on Windows.
- Added read-only access to the current key chain via `keys.keychain`.
- Renamed “hypertext” lexer and its corresponding module to “html”.
- Added configurable tab context menus via `textadept.menu.set_contextmenus()`.
- New GUI theme for Mac OSX.
- [Experimental] Merged separate lexer states into Textadept’s Lua state.
- Updated to Lua 5.2.3.
- Updated to Scintilla 3.3.7.

## 7.1 (11 Nov 2013)

Download:

- Textadept 7.1 – Win32
- Textadept 7.1 – Mac OSX Intel 10.5+
- Textadept 7.1 – Linux
- Textadept 7.1 – Linux x86_64
- Textadept 7.1 – Modules

Bugfixes:

- Textbox dialogs' `scroll_to` option works correctly.
- Emit autocompletion and hotspot events properly.
- Handle replacement captures with escapes properly.

Changes:

- Tabs for multiple buffers along with `ui.tabs` API.
- Split C/C++ lexer into separate lexers and replaced default “cpp” module with “ansi_c”.
- Find and replace text may utilize “%0” capture containing the entire match.
- Disable `textadept.editing.STRIP_TRAILING_SPACES` by default.
- `ui.clipboard_text` is no longer read-only.
- Added `events.FILE_CHANGED` event.

## 7.0 (01 Nov 2013)

Please see the 6 to 7 migration guide for upgrading from Textadept 6 to Textadept 7.

Download:

- Textadept 7.0 – Win32
- Textadept 7.0 – Mac OSX Intel 10.5+
- Textadept 7.0 – Linux
- Textadept 7.0 – Linux x86_64
- Textadept 7.0 – Modules

Bugfixes:

- Fixed bug with `buffer.SCFIND_REGEX` flag.
- Fixed OSX Command key recognition for click events.
- Fixed compile error with GTK3.

Changes:

- Added Assembly (NASM) lexer with compile and run commands.
- `textadept.adeptsense.goto_ctag()` can show all known tags now.
- `textadept.editing.enclose()` encloses the whole current word.

## 7.0 beta 5 (21 Oct 2013)

Download:

- Textadept 7.0 beta 5 – Win32
- Textadept 7.0 beta 5 – Mac OSX Intel 10.5+
- Textadept 7.0 beta 5 – Linux
- Textadept 7.0 beta 5 – Linux x86_64
- Textadept 7.0 beta 5 – Modules

Bugfixes:

- Show more helpful user-init startup error messages.
- Lua run command buffers output correctly.
- Fixed corner case in paragraph selection.
- Fixed corner case in block uncommenting.

Changes:

- Changed `ui.set_theme()` API to accept a table of property assignments.
- Added Nimrod lexer and compile and run commands.
- Use `textadept.editing.INDIC_BRACEMATCH` indicator for brace highlighting instead of styles.
- The `buffer` API applies to all buffers now, not just the global one.
- Added “Save All” to the menu.

## 7.0 beta 4 (01 Oct 2013)

Download:

- Textadept 7.0 beta 4 – Win32
- Textadept 7.0 beta 4 – Mac OSX Intel 10.5+
- Textadept 7.0 beta 4 – Linux
- Textadept 7.0 beta 4 – Linux x86_64
- Textadept 7.0 beta 4 – Modules

Bugfixes:

- Fixed various compile and install errors.
- Fixed error when block commenting plain text.

Changes:

- `events.disconnect()` now accepts function argument instead of ID.
- `buffer.filename` and all internal filenames are no longer encoded in UTF-8, but in `_CHARSET`.
- Removed many unused Scintilla constants and stripped many constants of `SC` and `SC_` prefixes.
- Changed marker margin symbols via properties.lua.
- Calling `textadept.editing.select_word()` repeatedly makes multiple selections.
- Renamed `buffer:convert_eo_ls()` to `convert_eols()`.
- Added `textadept.run.MARK_WARNING` marker.
- Renamed `textadept.run.compile_command` and `textadept.run.run_command` to `compile_commands` and `run_commands`, respectively.
- Renamed `textadept.run.error_detail` to `error_patterns` and changed its internal structure.
- Compile and run commands for languages that support them are now built-in along with their respective warning and error messages. The supplemental ones on the wiki are no longer needed.
- New `ui.dialogs` module for more user-friendly dialog support. Removed `ui.filteredlist()` as a result.
- Changed `io.open_file()` and `io.snapopen()` to accept tables of files and paths instead of “\n” delimited strings.

## 7.0 beta 3 (11 Sep 2013)

Download:

- Textadept 7.0 beta 3 – Win32
- Textadept 7.0 beta 3 – Mac OSX Intel 10.5+
- Textadept 7.0 beta 3 – Linux
- Textadept 7.0 beta 3 – Linux x86_64
- Textadept 7.0 beta 3 – Modules

Bugfixes:

- User functions that connect to `events.BUFFER_NEW` and `events.VIEW_NEW` are run on startup.
- Fixed potential crash caused by split views.

Changes:

- Copied constants from `_SCINTILLA.constants` into `buffer`.
- Renamed `events.LANGUAGE_MODULE_LOADED` to `events.LEXER_LOADED`.
- Renamed `gui` to `ui`.
- Renamed `_M.textadept` to `textadept`.
- New `events.INITIALIZED` event.
- Renamed `buffer:get_style_name()` to `buffer.style_name`.
- Renamed `ui.docstatusbar_text` to `ui.bufstatusbar_text`.
- Removed `textadept.bookmarks.BOOKMARK_COLOR`, `textadept.editing.HIGHLIGHT_COLOR`, and `textadept.run.ERROR_COLOR` while exposing their respective marker and indicator numbers for customization.
- Moved buffer IO functions into `io` module.
- Updated to CDK 5.0-20130901.

## 7.0 beta 2 (11 Aug 2013)

Download:

- Textadept 7.0 beta 2 – Win32
- Textadept 7.0 beta 2 – Mac OSX Intel 10.5+
- Textadept 7.0 beta 2 – Linux
- Textadept 7.0 beta 2 – Linux x86_64
- Textadept 7.0 beta 2 – Modules

Bugfixes:

- Fixed bug with theme loading when resetting.
- Fixed bug with property settings in `gui.set_theme()` not persisting.

Changes:

- New `gui.maximized` field so Textadept can remember its maximized state.
- Updated to Scintilla 3.3.4.

## 7.0 beta (11 Jul 2013)

Download:

- Textadept 7.0 beta – Win32
- Textadept 7.0 beta – Mac OSX Intel 10.5+
- Textadept 7.0 beta – Linux
- Textadept 7.0 beta – Linux x86_64
- Textadept 7.0 beta – Modules

Bugfixes:

- Added file type for Go.
- Fixed disorienting scrolling in some instances of splitting views.
- Fixed corner-case bug in Lua Pattern “Replace All”.

Changes:

- Renamed `_M.textadept.mime_types` to `_M.textadept.file_types`.
- Eliminated mime_types.conf files. Add or modify file type tables directly.
- Changed scrollbar look and feel on Mac OSX.

## 7.0 alpha 2 (01 Jul 2013)

Download:

- Textadept 7.0 alpha 2 – Win32
- Textadept 7.0 alpha 2 – Mac OSX Intel 10.5+
- Textadept 7.0 alpha 2 – Linux
- Textadept 7.0 alpha 2 – Linux x86_64
- Textadept 7.0 alpha 2 – Modules

Bugfixes:

- Fixed bug in user theme loading.
- Fixed “Enter” key autocompletion in curses.
- Fixed crash when transposing in an empty buffer.
- Fixed bug in find and run double-click event handlers.

Changes:

- Makefile improvements. See compiling for more information. The source release is no longer necessary.
- Removed `_G._LEXERPATH` and `_L._EXISTS()`.
- Renamed Adeptsense image fields.
- Renamed `_M.textadept.editing.STRIP_WHITESPACE_ON_SAVE` to `STRIP_TRAILING_SPACES`.
- `_M.textadept.editing.block_comment()` supports block comment delimiters.
- Block comments for languages is now built-in. The supplemental ones on the wiki are no longer needed.
- `gui.set_theme()` accepts key-value argument pairs for overriding theme properties.
- Removed `gui.select_theme()` since selected themes do not persist.
- Removed `_G.RESETTING` flag.
- Consolidated `_M.textadept.bookmarks.goto_*()` functionality into `_M.textadept.bookmarks.goto_mark()`.
- Updated to LuaJIT 2.0.2.
- New nightly builds.

## 7.0 alpha (01 Jun 2013)

Download:

- Textadept 7.0 alpha – Win32
- Textadept 7.0 alpha – Mac OSX Intel 10.5+
- Textadept 7.0 alpha – Linux
- Textadept 7.0 alpha – Linux x86_64
- Textadept 7.0 alpha – Source
- Textadept 7.0 alpha – Modules

Bugfixes:

- None.

Changes:

- Completely new theme implementation.
- New properties.lua for custom buffer and view properties.
- Updated to Scintilla 3.3.3.

## 6.6 (01 Jun 2013)

Download:

- Textadept 6.6 – Win32
- Textadept 6.6 – Mac OSX Intel 10.5+
- Textadept 6.6 – Linux
- Textadept 6.6 – Linux x86_64
- Textadept 6.6 – Source
- Textadept 6.6 – Modules

Bugfixes:

- Fixed GTK assertion errors in find/replace history.
- Command entry loses focus less often.
- Allow empty tables as keychains if they have metatables.
- Fixed caret placement in block comment/uncomment.
- Use ‘\n’ keycode in curses instead of ‘\r’.
- Fixed crash caused by split views.

Changes:

- Removed `_M[lang].set_buffer_properties()` functions. Set properties through `events.LANGUAGE_MODULE_LOADED` instead.
- Print the results of ‘=’ Lua commands.
- Updated to Scintilla 3.3.2.

## 6.6 beta (01 May 2013)

Download:

- Textadept 6.6 beta – Win32
- Textadept 6.6 beta – Mac OSX Intel 10.5+
- Textadept 6.6 beta – Linux
- Textadept 6.6 beta – Linux x86_64
- Textadept 6.6 beta – Source
- Textadept 6.6 beta – Modules

Bugfixes:

- Fixed rendering on Mac OSX retina displays.
- Fixed rectangle indicator display in curses.
- Fixed Fn key recognition on Mac OSX.
- Fixed compile errors for Mac OSX.
- Find Previous for Lua patterns works.

Changes:

- Textadept supports multiple curses platforms, not just ncurses. Make targets now use “curses” instead of “ncurses”.
- Better 16-color terminal support in lexer theme.
- Reduced the delay when pressing `Esc` in curses.
- Messagebox dialogs can show icons via `--icon` and `--icon-file`.
- New Win32 terminal version.
- New key modes functionality.
- Updated to Scintilla 3.3.1.
- Renamed `_G.buffer_new()` to `buffer.new()`.
- Changed the display of highlighted words, including removing `_M.textadept.editing.INDIC_HIGHLIGHT_ALPHA`.
- Changed `_M.textadept.editing.autocomplete_word()` API.
- Removed `_M.textadept.menu.menubar`, `_M.textadept.menu.contextmenu`, and `events.handlers` tables from the API.
- Moved `_M.textadept.filter_through` module functionality into `_M.textadept.editing.filter_through()`.
- Mark errors in compile/run commands and added `_M.textadept.run.goto_error()` menu options and key shortcuts.
- Renamed `gui.find.goto_file_in_list()` to `gui.find.goto_file_found()`.
- Consolidated `_M.textadept.editing.grow_selection()` functionality into `_M.textadept.editing.select_enclosed()`.
- Renamed `io.try_encodings` to `io.encodings`.

## 6.5 (01 Apr 2013)

Download:

- Textadept 6.5 – Win32
- Textadept 6.5 – Mac OSX Intel 10.5+
- Textadept 6.5 – Linux
- Textadept 6.5 – Linux x86_64
- Textadept 6.5 – Source
- Textadept 6.5 – Modules

Bugfixes:

- Only consider visible directories in _USERHOME/themes/ as themes.
- Indicator for highlighted words works in ncurses.
- Improved message double-clicking behavior for compile and run commands by adding `_M.textadept.run.cwd`.
- Fixed disorienting scrolling when wrapping only one search result.

Changes:

- Reset Lua state after selecting a new theme.
- Added `lfs.dir_foreach()`.
- Added file and directory filtering for Find in Files.
- Moved `_M.textadept.snapopen` into `io`.
- Renamed some `lexer` constants.
- Added Less, Literal Coffeescript, and Sass lexers.
- Updated to Scintilla 3.3.0.
- Updated to Lua 5.2.2.

## 6.4 (01 Mar 2013)

Download:

- Textadept 6.4 – Win32
- Textadept 6.4 – Mac OSX Intel 10.5+
- Textadept 6.4 – Linux
- Textadept 6.4 – Linux x86_64
- Textadept 6.4 – Source
- Textadept 6.4 – Modules

Bugfixes:

- Dialogs belong to the Textadept window.
- Fixed bug in documentation link generator.
- Fixed bug with indexable buffer properties that return strings.

Changes:

- Added command line switches for loading sessions on startup.
- Added command line switches for running Lua code on startup.
- Updated to Scintilla 3.2.5.
- Updated to LuaJIT 2.0.1.

## 6.3 (01 Feb 2013)

Download:

- Textadept 6.3 – Win32
- Textadept 6.3 – Mac OSX Intel 10.5+
- Textadept 6.3 – Linux
- Textadept 6.3 – Linux x86_64
- Textadept 6.3 – Source
- Textadept 6.3 – Modules

Bugfixes:

- Do not error on non-existant dropped URIs.
- Fixed crash in Python module when parsing some syntax error messages.

Changes:

- Use Scintilla API for ncurses mark mode.
- Updated to Scintilla 3.2.4.
- Added typeover characters.

## 6.2 (01 Jan 2013)

Download:

- Textadept 6.2 – Win32
- Textadept 6.2 – Mac OSX Intel 10.5+
- Textadept 6.2 – Linux
- Textadept 6.2 – Linux x86_64
- Textadept 6.2 – Source
- Textadept 6.2 – Modules

Bugfixes:

- None.

Changes:

- Greatly improved speed when loading large files.
- `make install` and `make ncurses install` install separate binaries on Linux.
- Changed API for `_M.textadept.snapopen.open()` and removed `PATHS`.

## 6.1 (11 Dec 2012)

Download:

- Textadept 6.1 – Win32
- Textadept 6.1 – Mac OSX Intel 10.5+
- Textadept 6.1 – Linux
- Textadept 6.1 – Linux x86_64
- Textadept 6.1 – Source
- Textadept 6.1 – Modules

Bugfixes:

- Do not set current directory when opening/saving files.
- Detect Linux processor arch better.
- Recognize special ncurses keys better.
- Fixed potential bug with determining `_HOME` on Linux.
- Fixed bug when opening non-existent files from the command line.
- LuaJIT compiles correctly on ARM now.

Changes:

- Improved speed and memory usage of lexers.
- Better Makefile support for building packages for Linux distros.
- Rewrote LuaDoc API documentation.
- Added French translation.
- Updated to LuaJIT 2.0.0.

## 6.0 (01 Nov 2012)

Please see the 5 to 6 migration guide for upgrading from Textadept 5 to Textadept 6.

Download:

- Textadept 6.0 – Win32
- Textadept 6.0 – Mac OSX Intel 10.5+
- Textadept 6.0 – Linux
- Textadept 6.0 – Linux x86_64
- Textadept 6.0 – Source
- Textadept 6.0 – Modules

Bugfixes:

- Handle rapidly pressing `Esc` twice in ncurses dialogs.
- Complete transition to `buffer.tab_size` from `buffer.indent`.
- Fixed regression in ncurses command selection.
- Fixed GUI menu key shortcut handling.
- Fixed string collation bug in ncurses due to CDK.
- Pass `Esc` to Scintilla correctly in ncurses.

Changes:

- Added key binding for toggling fold points.
- Added ncurses key bindings for bookmarks.
- Added `event.FIND_WRAPPED` event.
- Removed `_M.textadept.run.execute()`.
- Updated documentation and documentation formatting.
- Added Python module.
- Updated to Scintilla 3.2.3.
- Updated to LuaJIT 2.0.0-beta11.

## 6.0 beta 3 (01 Oct 2012)

Download:

- Textadept 6.0 beta 3 – Win32
- Textadept 6.0 beta 3 – Mac OSX Intel 10.5+
- Textadept 6.0 beta 3 – Linux
- Textadept 6.0 beta 3 – Linux x86_64
- Textadept 6.0 beta 3 – Source
- Textadept 6.0 beta 3 – Modules

Bugfixes:

- Cancelling in `buffer:close()` caused unwanted key propagation.
- Correctly emit `RUN_OUTPUT` events.
- Fixed bug with extra empty entry in the buffer browser.
- Fixed incremental find in ncurses.
- Fixed ncurses crash when pasting with no clipboard text.
- Keep termios disabled in ncurses CDK widgets.
- Do not write ncurses initialization errors over titlebar.
- Fixed bug in `string.iconv()`.

Changes:

- Attempt to autodetect locale using `LANG` environment variable.
- Removed `_M.textadept.menu.rebuild_command_tables()`.
- Manual and Lua API documentation largely re-written.
- Key Bindings reference moved from Appendix to `_M.textadept.keys` LuaDoc.
- Plain text lexer name changed from `container` to `text`.
- New application icon.
- Removed `./?.lua` and `./?.so` from `package.path` and `package.cpath`, respectively.
- Added marks for making selections in ncurses.

## 6.0 beta 2 (01 Sep 2012)

Download:

- Textadept 6.0 beta 2 – Win32
- Textadept 6.0 beta 2 – Mac OSX Intel 10.5+
- Textadept 6.0 beta 2 – Linux
- Textadept 6.0 beta 2 – Linux x86_64
- Textadept 6.0 beta 2 – Source
- Textadept 6.0 beta 2 – Modules

Bugfixes:

- Disabled `--help` switch to ncurses version due to terminal output mangling.
- ncurses replace entry can now be focused.
- Fixed ncurses memory leaks.
- Fixed multiple selection in Mac OSX.
- Show key shortcuts in ncurses `_M.textadept.menu.select_command()`.

Changes:

- Added `make install` and `make uninstall` rules for optional installation.
- Updated manual with ncurses key commands.
- Consolidated `_M.textadept.bookmarks.add()` and `_M.textadept.bookmarks.remove()` into `_M.textadept.bookmarks.toggle()`.
- Updated manual images.
- `_M.textadept.snapopen.DEFAULT_DEPTH` is now `99` since `MAX` is the limiting factor.
- Use constant names in theme options instead of nondescript integers.
- Updated to Scintilla 3.2.2.

## 6.0 beta (01 Aug 2012)

Download:

- Textadept 6.0 beta – Win32
- Textadept 6.0 beta – Mac OSX Intel 10.5+
- Textadept 6.0 beta – Linux
- Textadept 6.0 beta – Linux x86_64
- Textadept 6.0 beta – Source
- Textadept 6.0 beta – Modules

Bugfixes:

- Lots of bugfixes to the experimental ncurses version.

Changes:

- Removed Lua, Ruby, and PHP modules' `goto_required()` functions.
- Moved `_M.textadept.editing.prepare_for_save()` directly into event handler.
- Moved `_M.textadept.session.prompt_load()` and `prompt_save()` functionality into `_M.textadept.session.load()` and `_M.textadept.session.save()`.
- Removed `_G.user_dofile()`.
- Converted some `buffer` “get” and “set” functions into properties.
- Moved `_M.textadept.adeptsense.complete_symbol()` and `show_documentation()` functionality into `_M.textadept.adeptsense.complete()` and `show_apidoc()`.
- New 64-bit Windows version (note: without LuaJIT).
- Updated to Scintilla 3.2.1.

## 5.5 beta (01 Jul 2012)

Download:

- Textadept 5.5 beta – Win32
- Textadept 5.5 beta – Mac OSX Intel 10.5+
- Textadept 5.5 beta – Linux
- Textadept 5.5 beta – Linux x86_64
- Textadept 5.5 beta – Source
- Textadept 5.5 beta – Modules

Bugfixes:

- None.

Changes:

- Experimental ncurses support.
- No more `'gtk-'` stock menu item support and changed `'separator'` to `''`.
- Renamed `gui.gtkmenu()` to `gui.menu()`.
- Changed `gui.statusbar_text` to be write-only.
- Changed ‘Quit’ key command to ‘Ctrl+Q’ on Win32 and Linux.
- Show text that could not be localized.
- Changed `make` commands for compiling Textadept.
- x86_64 binary provides `libpng12` executables by default.
- Can cross compile to Mac OSX from Linux.
- Updated to Lua 5.2.1.
- Updated to LuaJIT 2.0.0-beta10.

## 5.4 (01 Jun 2012)

Download:

- Textadept 5.4 – Win32
- Textadept 5.4 – Mac OSX Intel 10.5+
- Textadept 5.4 – Linux
- Textadept 5.4 – Linux x86_64
- Textadept 5.4 – Source
- Textadept 5.4 – Modules

Bugfixes:

- None.

Changes:

- Updated to Scintilla 3.2.0.

## 5.3 (01 May 2012)

Download:

- Textadept 5.3 – Win32
- Textadept 5.3 – Mac OSX Intel 10.5+
- Textadept 5.3 – Linux
- Textadept 5.3 – Linux x86_64
- Textadept 5.3 – Source
- Textadept 5.3 – Modules

Bugfixes:

- Fixed bug with run/compile commands in LuaJIT version.
- User annotation preferences are preserved.
- Fixed bug with number representation in some locales.

Changes:

- Annotations are used for showing run/compile command output.
- Textadept is single-instance by default on Linux and Mac OSX.
- Textadept requires GTK 2.18 or higher now instead of 2.16.
- The provided Textadept binaries require GLib 2.28 or higher.
- Updated to Scintilla 3.1.0.

## 5.2 (01 Apr 2012)

Download:

- Textadept 5.2 – Win32
- Textadept 5.2 – Mac OSX Intel 10.5+
- Textadept 5.2 – Linux
- Textadept 5.2 – Linux x86_64
- Textadept 5.2 – Source
- Textadept 5.2 – Modules

Bugfixes:

- Fixed LuaDoc for `buffer:get_lexer()`.
- Fixed bug with relative paths from command line files.
- `buffer:get_lexer(true)` is used more often when it should be.
- Improved message double-clicking behavior for run and compile commands.

Changes:

- `_M.set_buffer_properties()` is now optional for language modules.
- Added keypad keys to `keys.KEYSYMS`.
- `_G.timeout()` accepts fractional seconds.
- Replaced `scripts/update_doc` with `src/Makefile` targets.
- New Manual and LuaDoc HTML page formatting.
- `_M.textadept.editing.autocomplete_word()` accepts default words.
- Added documentation on generating LuaDoc and Lua Adeptsense.
- Moved `Markdown:` comments into LuaDoc.
- Added Spanish and German translations.
- Use GTK 2.24 on Windows.
- Updated to Scintilla 3.0.4.

## 5.1 (01 Mar 2012)

Download:

- Textadept 5.1 – Win32
- Textadept 5.1 – Mac OSX Intel 10.5+
- Textadept 5.1 – Linux
- Textadept 5.1 – Linux x86_64
- Textadept 5.1 – Source
- Textadept 5.1 – Modules

Bugfixes:

- Fixed crash caused by `gui.filteredlist()` dialogs.
- Support multiple `@return` tags in Lua Adeptsense.
- Fixed display of `buffer._type` when it has slashes in its name.

Changes:

- Better Lua Adeptsense formatting.
- Use new Cocoa-based GtkOSXApplication library for better OSX support.
- Lexers with no tokens can be styled manually.
- Added more OSX default key shortcuts.

## 5.0 (01 Feb 2012)

Please see the 4 to 5 migration guide for upgrading from Textadept 4 to Textadept 5.

Download:

- Textadept 5.0 – Win32
- Textadept 5.0 – Mac OSX Intel 10.5+
- Textadept 5.0 – Linux
- Textadept 5.0 – Linux x86_64
- Textadept 5.0 – Source
- Textadept 5.0 – Modules

Bugfixes:

- Fixed bug with recent files in sessions.

Changes:

- Added default extension and folder filters in `modules/textadept/snapopen.lua`.
- Added ChucK lexer.
- Updated to Scintilla 3.0.3.
- Also include LuaJIT executables in releases.

## 5.0 beta (11 Jan 2012)

Download:

- Textadept 5.0 beta – Win32
- Textadept 5.0 beta – Mac OSX Intel 10.5+
- Textadept 5.0 beta – Linux
- Textadept 5.0 beta – Linux x86_64
- Textadept 5.0 beta – Source
- Textadept 5.0 beta – Modules

Bugfixes:

- Fixed bug in `reset()` from update to Lua 5.2.

Changes:

- Changed `locale.localize()` to global `_L` table and removed `locale` module.
- Renamed `_m` to `_M`.
- Do not clear registered images when autocompleting with Adeptsense.
- Renamed editing module’s `current_word()` to `select_word()`.
- Updated manual.

## 5.0 alpha (21 Dec 2011)

Download:

- Textadept 5.0 alpha – Win32
- Textadept 5.0 alpha – Mac OSX Intel 10.5+
- Textadept 5.0 alpha – Linux
- Textadept 5.0 alpha – Linux x86_64
- Textadept 5.0 alpha – Source
- Textadept 5.0 alpha – Modules

Bugfixes:

- None.

Changes:

- Updated to Lua 5.2.
- Updated sections in the manual to reflect Lua 5.2 changes.
- Textadept can be compiled with LuaJIT.

## 4.3 (01 Dec 2011)

Download:

- Textadept 4.3 – Win32
- Textadept 4.3 – Mac OSX Intel 10.5+
- Textadept 4.3 – Linux
- Textadept 4.3 – Linux x86_64
- Textadept 4.3 – Source
- Textadept 4.3 – Modules

Bugfixes:

- Fixed bug with opening files in the current directory from the command line.
- Fixed erroneous charset conversion.

Changes:

- Added on-the-fly theme switching.
- All new `light` and `dark` themes.
- Removed `_m.textadept.editing.select_style()`.
- Simplify theming via gtkrc by naming `GtkWindow` only.
- Updated to Scintilla 3.0.1.

## 4.2 (01 Nov 2011)

Download:

- Textadept 4.2 – Win32
- Textadept 4.2 – Mac OSX Intel 10.5+
- Textadept 4.2 – Linux
- Textadept 4.2 – Linux x86_64
- Textadept 4.2 – Source
- Textadept 4.2 – Modules

Bugfixes:

- Fixed bug with `%n` in Replace introduced in 4.1.
- Fixed Adeptsense autocomplete for single item.

Changes:

- Updated to Scintilla 3.0.0.

## 4.1 (01 Oct 2011)

Download:

- Textadept 4.1 – Win32
- Textadept 4.1 – Mac OSX Intel 10.5+
- Textadept 4.1 – Linux
- Textadept 4.1 – Linux x86_64
- Textadept 4.1 – Source
- Textadept 4.1 – Modules

Bugfixes:

- Only fold when clicking on fold margin, not any sensitive one.
- Fixed bug with `CALL_TIP_CLICK` event disconnect in Adeptsense.
- Fixed bug with autocomplete and capitalization.

Changes:

- Handle mouse dwell events `DWELL_START` and `DWELL_END`.
- Rearranged `Tools` menu slightly.
- Slight API changes:
  - `_BUFFERS` and `_VIEWS` structure changed.
  - Removed `buffer.doc_pointer` and `view.doc_pointer`.
  - Added `view.buffer` field.
  - Renamed `gui.check_focused_buffer()` to `buffer:check_global()`.
  - `view:goto_buffer()` and `gui.goto_view()` arguments make sense now. (May require changes to custom key commands.)
- Directory is remembered in file chooser dialog after open or save as.
- Added language-specific context menu support.
- Use LuaCoco patch for Lua 5.1.4.
- Use lexer at the caret for key commands and snippets.
- Updated to Scintilla 2.29.

## 4.0 (01 Sep 2011)

Please see the 3 to 4 migration guide for upgrading from Textadept 3 to Textadept 4.

Download:

- Textadept 4.0 – Win32
- Textadept 4.0 – Mac OSX Intel 10.5+
- Textadept 4.0 – Linux
- Textadept 4.0 – Linux x86_64
- Textadept 4.0 – Source
- Textadept 4.0 – Modules

Bugfixes:

- Makefile should only link to `libdl.so` on Linux/BSD.
- Fixed memory access bug in `gui.dialog()`.
- Autocompletion list sort order respects `buffer.auto_c_ignore_case` now.
- Fixed split view focus bug with the same buffer in two views.
- Set new buffer EOL mode properly on Mac OSX.

Changes:

- Added Russian translation.
- Changed some key commands from 4.0 beta 2.
- Do not hide the statusbar when the command entry has focus.

## 4.0 beta 2 (11 Aug 2011)

Download:

- Textadept 4.0 beta 2 – Win32
- Textadept 4.0 beta 2 – Mac OSX Intel 10.5+
- Textadept 4.0 beta 2 – Linux
- Textadept 4.0 beta 2 – Linux x86_64
- Textadept 4.0 beta 2 – Source
- Textadept 4.0 beta 2 – Modules

Bugfixes:

- Fixed transpose characters bug at end of buffer.
- Do not autosave over explicitly loaded session.
- Fixed startup crash on Mac OSX.
- Fixed resize crash on Mac OSX Lion.

Changes:

- Added Scala lexer.
- Add recent file list to session files.
- Autocomplete supports multiple selections.
- Swapped OSX `c` and `m` key command definition modifiers.
- Changed some key bindings from 4.0 beta.

## 4.0 beta (01 Aug 2011)

Download:

- Textadept 4.0 beta – Win32
- Textadept 4.0 beta – Mac OSX Intel 10.5+
- Textadept 4.0 beta – Linux
- Textadept 4.0 beta – Linux x86_64
- Textadept 4.0 beta – Source
- Textadept 4.0 beta – Modules

Bugfixes:

- None.

Changes:

- Mac OSX uses GTK 2.24.
- Added `io.open_recent_file()`.
- Changes to localization file again.
- `buffer` functions may omit the first `buffer` argument (e.g. `buffer.line_down()` is allowed).
- Complete overhaul of menus and added accelerators to menu items.
- Renamed `_m.textadept.editing.SAVE_STRIPS_WS` to `_m.textadept.editing.STRIP_WHITESPACE_ON_SAVE`.
- Renamed `_m.textadept.editing.select_scope()` to `_m.textadept.editing.select_style()`.
- Completely new set of key commands.
- Updated to Scintilla 2.28.

## 3.9 (01 Jul 2011)

Download:

- Textadept 3.9 – Win32
- Textadept 3.9 – Mac OSX Intel 10.5+
- Textadept 3.9 – Linux
- Textadept 3.9 – Linux x86_64
- Textadept 3.9 – Source
- Textadept 3.9 – Modules

Bugfixes:

- Fixed bug for when `gui.dialog` steals focus.

Changes:

- Added support for GTK 3.0.
- Use ID generator functions for marker, indicator, and user list IDs.
- Updated to Scintilla 2.27.
- Use string constants for event names.
- Compile and run commands emit events.
- Enhanced Luadoc and Lua Adeptsense.
- Added `fold.line.comments` property for folding multiple single-line comments.
- Use GTK 2.22 on Windows.
- Can localize the labels and buttons in the GUI find frame.
- Added ConTeXt lexer.

## 3.8 (11 Jun 2011)

Download:

- Textadept 3.8 – Win32
- Textadept 3.8 – Mac OSX Intel 10.5+
- Textadept 3.8 – Linux
- Textadept 3.8 – Linux x86_64
- Textadept 3.8 – Source
- Textadept 3.8 – Modules

Bugfixes:

- Removed non-existant key chain.
- Fixed bug in snippets.

Changes:

- Updated Adeptsense and documentation.
- `events.handlers` is accessible.
- Added menu mnemonics for indentation size.
- Added support for indicator and hotspot events.
- Updated documentation for installing official modules.
- Updated to Scintilla 2.26.
- Writing custom folding for lexers is much easier now.
- Added native folding for more than 60% of existing lexers. The rest still use folding by indentation by default.

## 3.7 (01 May 2011)

Download:

- Textadept 3.7 – Win32
- Textadept 3.7 – Mac OSX Intel 10.5+
- Textadept 3.7 – Linux
- Textadept 3.7 – Linux x86_64
- Textadept 3.7 – Source
- Textadept 3.7 – Modules

Bugfixes:

- Fixed bug in `buffer:get_lexer()`.

Changes:

- Changed Mac OSX Adeptsense complete key command from `~` to `Ctrl+Escape`.
- Added PHP module.

## 3.7 beta 3 (01 Apr 2011)

Download:

- Textadept 3.7 beta 3 – Win32
- Textadept 3.7 beta 3 – Mac OSX Intel 10.5+
- Textadept 3.7 beta 3 – Linux
- Textadept 3.7 beta 3 – Linux x86_64
- Textadept 3.7 beta 3 – Source
- Textadept 3.7 beta 3 – Modules

Bugfixes:

- Small Adeptsense bugfixes.
- Snapopen respects filesystem encoding.
- Standard input dialogs have “Cancel” button by default.

Changes:

- Adeptsense tweaks for better completion and apidoc support.
- Language modules load a user `post_init.lua` script if it exists.
- Added Ruby on Rails lexer and module.
- Added RHTML module.
- Updated mime-types and prioritize by shebang, pattern, and then file extension.
- `buffer:get_lexer(true)` returns the lexer at the caret position.
- Adeptsense can be triggered in embedded lexers now.
- Added C standard library and Lua C API to C/C++ Adeptsense.
- Lua module fields are now in Lua Adeptsense.
- Updated to Scintilla 2.25.
- Rewrote `_m.textadept.snippets` with syntax changes.
- `Alt+I` (`Ctrl+I` on Mac OSX) is now “Select Snippet” instead of “Show Style”. “Show Style” is now `Ctrl+Alt+Shift+I` (`Ctrl+Apple+Shift+I`).
- Adeptsense can exclude types matched by `sense.syntax.type_declarations` patterns.
- `Ctrl+T, V` (`Apple+T, V` on Mac OSX) keychain for toggling whitespace, wrap, etc. is now `Ctrl+Shift+B` (`Apple+Shift+B`).
- Key commands and menu definition syntax changed.
- Snapopen allows for multiple-selection.
- `gui.print()` handles `nil` and non-string arguments properly.
- Officially supported modules have their own repositories and are available as a separate download.

## 3.7 beta 2 (01 Mar 2011)

Download:

- Textadept 3.7 beta 2 – Win32
- Textadept 3.7 beta 2 – Mac OSX Intel 10.5+
- Textadept 3.7 beta 2 – Linux
- Textadept 3.7 beta 2 – Linux x86_64
- Textadept 3.7 beta 2 – Source

Bugfixes:

- Fixed bug with Win32 paths in Adeptsense `goto_ctag()`.
- Adeptsense could not recognize some symbols.
- Handle `\n` sequences correctly in Adeptsense apidoc.
- Fixed bug with Adeptsense C/C++ type declarations.
- Adeptsense can now recognize more than 1 level of inheritence.
- Keychain is cleared on key command error.
- Fixed infinite loop bug in `_m.textadept.editing.select_scope()`.

Changes:

- Updated to Scintilla 2.24.
- Updated mime-types.
- Line margin width is now `4`.
- Adeptsense completion list images are accessible via scripts.
- Added class context completion to Adeptsense.
- Added class type-inference through variable assignment to Adeptsense.
- Added Adeptsense tutorial.
- Added `_m.textadept.adeptsense.always_show_globals` setting for showing globals in completion lists.
- `Ctrl+H` (highlight word) is now `Ctrl+Shift+H`.
- `Ctrl+H` now shows Adeptsense documentation.
- Added Adeptsense `complete()` and `show_documentation()` functions to the menu.
- Language modules condensed into single `init.lua` file.
- Added `sense.syntax.word_chars` to Adeptsense.
- Included libpng12 build for 64-bit Debian-based Linux distros (Ubuntu).
- Added CSS, HTML, Java, and Ruby modules with Adeptsenses.

## 3.7 beta (01 Feb 2011)

Download:

- Textadept 3.7 beta – Win32
- Textadept 3.7 beta – Mac OSX Intel 10.5+
- Textadept 3.7 beta – Linux
- Textadept 3.7 beta – Linux x86_64
- Textadept 3.7 beta – Source

Bugfixes:

- `update_ui` is called properly for `buffer_new` and `view_new` events.
- Use proper pointer type for Scintilla calls.
- Fixed bug with loading lexers from `_USERHOME` on Win32.

Changes:

- More informative error message for unfocused buffer.
- Added Adeptsense, a smarter form of autocompletion for programming languages.
- Emit a `language_module_loaded` as appropriate.
- Added indentation settings to “Buffer” menu (finally).
- Added `gui.filteredlist()` shortcut for `gui.dialog('filteredlist', ...)`.
- Can navigate between bookmarks with a filteredlist.
- Language-specific `char_matches` and `braces` can be defined.
- `command_entry_keypress` event accepts modifier keys.

## 3.6 (01 Jan 2011)

Download:

- Textadept 3.6 – Win32
- Textadept 3.6 – Mac OSX Intel 10.5+
- Textadept 3.6 – Linux
- Textadept 3.6 – Linux x86_64
- Textadept 3.6 – Source

Bugfixes:

- Fixed infinite recursion errors caused in events.
- Fix statusbar update bug with key chains.
- Do not emit `buffer_new` event when splitting the view.

Changes:

- `buffer.rectangular_selection_modifier` on Linux is the Super/Windows key.
- Improved HTML lexer.
- Added Markdown, BibTeX, CMake, CUDA, Desktop Entry, F#, GLSL, and Nemerle lexers.
- Added `_m.textadept.filter_through` module for shell commands.
- Moved GUI events from `core/events.lua` to `core/gui.lua`.
- Separated key command manager from key command definitions.

## 3.5 (01 Dec 2010)

Download:

- Textadept 3.5 – Win32
- Textadept 3.5 – Mac OSX Intel 10.5+
- Textadept 3.5 – Linux
- Textadept 3.5 – Linux x86_64
- Textadept 3.5 – Source

Bugfixes:

- Fixed bug introduced when exposing Find in Files API.

Changes:

- Lua files are syntax-checked for errors on save.
- Menus are easier to create.
- Changed `_m.textadept.editing.enclose()` behavior.
- Win32 and Mac OSX packages are all-in-one bundles; GTK is no longer an external dependency.
- New manual.
- Added `file_after_save` event.

## 3.4 (01 Nov 2010)

Download:

- Textadept 3.4 – Win32
- Textadept 3.4 – Mac OSX Intel 10.5+
- Textadept 3.4 – Linux
- Textadept 3.4 – Linux x86_64
- Textadept 3.4 – Source

Bugfixes:

- Fixed menu item conflicts.
- Pressing `Cancel` in the Switch Buffers dialog does not jump to the selected buffer anymore.
- Autocomplete lists sort properly for machines with a different locale.
- Statusbar is not cleared when set from a key command.
- Unreadable files are handled appropriately.

Changes:

- Multi-language lexers (HTML, PHP, RHTML, etc.) are processed as fast as single language ones, resulting in a huge speed improvement.
- An `update_ui` event is triggered after a Lua command is entered.
- `gui.dialog()` can take tables of strings as arguments now.
- `_m.textadept.snapopen.open()` takes a recursion depth as a parameter and falls back on a `DEFAULT_DEPTH` if necessary.
- Removed `_m.textadept.editing.smart_cutcopy()` and `_m.textadept.editing.squeeze()` functions.
- Added `_m.textadept.editing.SAVE_STRIPS_WS` option to disable strip whitespace on save.
- Changed locale implementation. Locale files are much easier to create now.
- `gui.statusbar_text` is now readable instead of being write-only.
- Can highlight all occurances of a word.
- Added jsp lexer.
- More consistant handling of `\` directory separator for Win32.
- Consolidated `textadept.h` and `lua_interface.c` into single `textadept.c` file.
- Added `_G.timeout()` function for calling functions and/or events after a period of time.
- Find in files is accessible through find API.
- Updated to Scintilla 2.22.
- Renamed `_G.MAC` to `_G.OSX`.

## 3.3 (01 Oct 2010)

Download:

- Textadept 3.3 – Win32
- Textadept 3.3 – Mac OSX Intel 10.5+
- Textadept 3.3 – Linux
- Textadept 3.3 – Linux x86_64
- Textadept 3.3 – Source

Bugfixes:

- Fixed buggy snippet menu.

Changes:

- Added `_m.textadept.snapopen` module with menu options for rapidly opening files.

## 3.2 (01 Sep 2010)

Download:

- Textadept 3.2 – Win32
- Textadept 3.2 – Mac OSX Intel 10.5+
- Textadept 3.2 – Linux
- Textadept 3.2 – Linux x86_64
- Textadept 3.2 – Source

Bugfixes:

- Fixed “Replace All” infinite loop bug.

Changes:

- Updated to the new Scintillua that does not required patched Scintilla.
- Updated to Scintilla 2.21.

## 3.1 (21 Aug 2010)

Download:

- Textadept 3.1 – Win32
- Textadept 3.1 – Mac OSX Intel 10.5+
- Textadept 3.1 – Linux
- Textadept 3.1 – Linux x86_64
- Textadept 3.1 – Source

Bugfixes:

- Fixed memory leak in Mac OSX.

Changes:

- Refactored key commands to support propagation.
- Updated to Scintilla 2.20.
- Added Lua autocompletion.

## 3.0 (01 Jul 2010)

Please see the 2 to 3 migration guide for upgrading from Textadept 2 to Textadept 3.

Download:

- Textadept 3.0 – Win32
- Textadept 3.0 – Mac OSX Intel 10.5+
- Textadept 3.0 – Linux
- Textadept 3.0 – Linux x86_64
- Textadept 3.0 – Source

Bugfixes:

- None

Changes:

- More accurate CSS and Diff lexers.

## 3.0 beta (21 Jun 2010)

Download:

- Textadept 3.0 beta – Win32
- Textadept 3.0 beta – Mac OSX Intel 10.5+
- Textadept 3.0 beta – Linux
- Textadept 3.0 beta – Linux x86_64
- Textadept 3.0 beta – Source

Bugfixes:

- Fixed Mac OSX paste issue.
- Fixed `buffer:text_range()` argcheck problem.

Changes:

- Remove initial “Untitled” buffer when necessary.
- Moved core extension modules into `textadept` module.
- New API.
- `~/.textadept/init.lua` is created for you if one does not exist.
- No more autoload of `~/.textadept/key_commands.lua` and `~/.textadept/snippets.lua`
- Updated to Scintilla 2.12.
- Abbreviated Lua commands in the command entry.
- Dynamic command line arguments.
- Added statusbar notification on `reset()`.
- Added Gtkrc, Prolog, and Go lexers.

## 2.2 (11 May 2010)

Download:

- Textadept 2.2 – Win32
- Textadept 2.2 – Mac OSX Intel 10.5+
- Textadept 2.2 – Linux
- Textadept 2.2 – Linux x86_64
- Textadept 2.2 – Source

Bugfixes:

- Save buffer before compiling or running.
- Fixed error in the manual for `~/.textadept/init.lua` example.
- Ignore `file://` prefix for filenames.

Changes:

- `_USERHOME` comes before `_HOME` in `package.path` so `require` searches `~/.textadept/` first.

## 2.2 beta 2 (01 May 2010)

Download:

- Textadept 2.2 beta 2 – Win32
- Textadept 2.2 beta 2 – Mac OSX Intel 10.5+
- Textadept 2.2 beta 2 – Linux
- Textadept 2.2 beta 2 – Linux x86_64
- Textadept 2.2 beta 2 – Source

Bugfixes:

- Fixed crash with `buffer:text_range()`.
- Fixed snippets bug with `%n` sequences.
- Respect tab settings for snippets.
- Fixed help hanging bug in Win32.
- Fixed Lua module commands bug.

Changes:

- Added BSD support.
- Removed kill-ring from editing module.
- Compile and Run commands are in language modules.
- Block comment strings are in language modules now.
- Remove “Untitled” buffer when necessary.
- Moved “Search” menu into “Tools” menu to prevent `Alt+S` key conflict.
- Rewrote lexers implementation.
- Added Inform, Lilypond, and NSIS lexers.
- `_m.textadept.editing.enclosure` is now an accessible table.

## 2.2 beta (01 Apr 2010)

Download:

- Textadept 2.2 beta – Win32
- Textadept 2.2 beta – Mac OSX Intel 10.5+
- Textadept 2.2 beta – Linux
- Textadept 2.2 beta – Linux x86_64
- Textadept 2.2 beta – Source

Bugfixes:

- Fixed transform bug in snippets.
- Fixed bug with Io lexer mime-type.
- Fixed embedded css/javascript bug in HTML lexer.

Changes:

- Removed `_m.textadept.mlines` module since Scintilla’s multiple selections supercedes it.
- Removed side pane.
- New `gui.dialog(‘filteredlist’, …) from gtdialog.
- Can select buffer from filteredlist dialog (replacing side pane buffer list).
- Can select lexer from filteredlist dialog.
- Can have user `key_commands.lua`, `snippets.lua`, `mime_types.conf`, `locale.conf` that are loaded by their respective modules.
- Added Matlab/Octave lexer.
- Backspace deletes auto-inserted character pairs.
- Added notification for session files not found.
- Snippets use multiple carets.
- Removed api file support.

## 2.1 (01 Mar 2010)

Download:

- Textadept 2.1 – Win32
- Textadept 2.1 – Mac OSX Intel 10.5+
- Textadept 2.1 – Linux
- Textadept 2.1 – Linux x86_64
- Textadept 2.1 – Source

Bugfixes:

- Do not close files opened from command line when loading PM session.
- Fixed bug for running a file with no path.
- Fixed error message for session file not being found.
- Fixed key command for word autocomplete on Win32.
- Changed conflicting menu shortcut for Lexers menu.
- Fixed typos in templates generated by modules PM browser.

Changes:

- Added Dot and JSON lexers.
- Search `_USERHOME` in addition to `_HOME` for themes.
- Added command line switch for not loading/saving session.
- Modified key commands to be more key-layout agnostic.
- Added `reset_before` and `reset_after` events while `textadept.reset()` is being run.
- Reload current lexer module after `textadept.reset()`.
- Added `~/.textadept/modules/` to `package.path`.
- Updated to Scintilla 2.03.
- Modified quit and close dialogs to be more readable.

## 2.0 (01 Oct 2009)

Download:

- Textadept 2.0 – Win32
- Textadept 2.0 – Mac OSX Intel 10.5+
- Textadept 2.0 – Linux
- Textadept 2.0 – Linux x86_64
- Textadept 2.0 – Source

Bugfixes:

- Fixed bug with reloading PM width from session file.
- Only show a non-nil PM context menu.
- Fixed bug in `modules/textadept/lsnippets.lua`.
- Fixed bug in `core/ext/mime_types.lua` caused during `textadept.reset()`.
- Close all buffers before loading a session.
- Identify `shellscript` files correctly.
- D lexer no longer has key-command conflicts.

Changes:

- Refactored `modules/textadept/lsnippets.lua`.
- Updated key commands.
- Allow PM modules in the `~/.textadept` user directory.
- Added `style_whitespace` to lexers for custom styles.
- Added standard `F3` key command for “Find Next” for Windows/Linux.

## 2.0 beta (31 Jul 2009)

Download:

- Textadept 2.0 beta – Win32
- Textadept 2.0 beta – Linux
- Textadept 2.0 beta – Linux x86_64
- Textadept 2.0 beta – Source

Bugfixes:

- Alphabetize lexer list.
- Fixed some locale issues.
- Fixed some small memory leaks.
- Try a list of encodings rather than just UTF-8 so “conversion failed” does not happen so often.
- Restore a manually set lexer.

Changes:

- Removed `_m.textadept.macros` module and respective PM browser (use Lua instead).
- Linux version can be installed and run from anywhere; no need to recompile anymore.
- Added many more events to hook into lots of core functionality.
- Updated to Scintilla 1.79.
- Run module allows more flexible compile commands and run commands.
- Save project manager cursor over sessions.
- Allow mime-types and compile and run commands to be user-redefinable in user scripts.
- Use `~/.textadept/` for holding user lexers, themes, sessions, etc.
- Added “Help” menu linking to Manual and LuaDoc.
- Textadept compiles as C99 code. (Drops Microsoft Visual Studio support.)
- Sessions functionality moved to `modules/textadept/session.lua` from `core/file_io.lua`.
- The `char_added` event now passes an int, not a string, to handler functions.
- Replaced cocoaDialog and lua_dialog with my C-based gtdialog.
- Incremental find via the Lua command entry.

- NO dependencies other than GTK on all platforms.

  - Win32 no longer requires the MSVC++ 2008 Runtime.
  - Linux no longer requires `libffi`.
  - Mac OSX no longer requires cocoaDialog.

- Can cross compile to Win32 from Linux.

- Removed confusing `local function` and `local table` LuaDoc.
- Rewrote the manual and most of the documentation.

## 1.6 (01 Apr 2009)

Download:

- Textadept 1.6 – Win32
- Textadept 1.6 – Mac OSX Intel 10.5+
- Textadept 1.6 – Linux
- Textadept 1.6 – Linux x86_64
- Textadept 1.6 – Source

Bugfixes:

- Fixed `NULL` byte bug associated with Lua interface due to multi-encoding support.
- Find marker is colored consistently.
- Fixed issue with buffer browser cursor saving.
- Fixed block character insertion issue on GTK-OSX.

Updates:

- Trimmed theme files.
- Added `file_before_save` event.

## 1.6 beta (01 Mar 2009)

Download:

- Textadept 1.6 beta – Win32
- Textadept 1.6 beta – Mac OSX Intel 10.5+
- Textadept 1.6 beta – Linux
- Textadept 1.6 beta – Linux x86_64
- Textadept 1.6 beta – Source

Bugfixes:

- Fixed bookmarks bugs.
- PM browsers are not re-added to the list again on `textadept.reset()`.
- Fixed ctags PM browser bug with filenames.
- Marker colors are set for all views now.
- Fixed never-ending “reload modified file?” dialog bug.
- Fixed key command for `m_snippets.list`.
- Fixed issues with `_m.textadept.run` module.
- Fixed document modification status bug for unfocused split views.
- Fixed filename encoding issues for Windows.

Updates:

- Added key commands and menu items to navigate “Find in Files” list.
- The `recent_files` popup list behaves better.
- Attempt to preserve existing EOL mode for opened files.
- Add drag-and-dropped directories to the PM browser list.
- Removed `project` PM browser.
- Multiple character encoding support for opening and saving files.

## 1.5 (20 Feb 2009)

Download:

- Textadept 1.5 – Win32
- Textadept 1.5 – Mac OSX Intel 10.5+
- Textadept 1.5 – Linux
- Textadept 1.5 – Linux x86_64
- Textadept 1.5 – Source

Bugfixes:

- Fixed some corner cases in Find in Files user interface.
- Fixed some OSX key command issues for consistency.
- Fixed some key command modifiers for “enclose in” series.

Updates:

- Consolidated `core/ext/key_commands_{std,mac}.lua` into single `core/ext/key_commands.lua`.
- Can use the `Tab` and `Shift+Tab` keys for snippets now.
- Removed support for Textmate-style snippets in favor of Lua-style snippets.
- Load drag-and-dropped directories into file browser.
- Can toggle showing “dot” files in file browser.
- Prompt for file reload when files are modified outside Textadept.
- Added `textadept.context_menu` field for right-click inside Scintilla.
- Project Manager cursors are saved and restored.
- Only use escape sequences in Lua pattern searches.
- Rewrote `modules/textadept/run.lua` to be easier to use and configure.
- Find in Files marks the selected line for easier reference.
- Save special buffers in session file (e.g. error buffer, message buffer, etc.)
- Moved mime-types into `core/ext/mime_types.conf` configuration file.
- Moved localization into `core/locale.conf` configuration file.

## 1.4 (10 Feb 2009)

Download:

- Textadept 1.4 – Win32
- Textadept 1.4 – Mac OSX Intel 10.5+
- Textadept 1.4 – Linux
- Textadept 1.4 – Linux x86_64
- Textadept 1.4 – Source

Bugfixes:

- Handle empty clipboard properly.
- Fixed some widget focus issues.
- Fixed a couple Find in Files bugs.
- Workaround for GTK-OSX pasting issue.

Updates:

- Added menu options for changing line endings.
- The Project Manager Entry responds better.
- Improved Lua State integrity for critical data.
- Keep only 10 items in Find/Replace history.
- Special buffers are not “Untitled” anymore.
- Moved `textadept.locale` table to `_G`.

## 1.3 (30 Jan 2009)

Download:

- Textadept 1.3 – Win32
- Textadept 1.3 – Mac OSX Intel 10.5+
- Textadept 1.3 – Linux
- Textadept 1.3 – Linux x86_64
- Textadept 1.3 – Source

Bugfixes:

- Binary files are opened and handled properly.
- Drag-and-dropped files are now opened in the correct split view they were dropped in.
- Fixed some various GTK-OSX UI issues.
- Fixed a special case of “Replace All”.
- Clicking “Ok” closes any error dialogs on init.
- Fixed statusbar glitch when creating new buffers.
- Windows' CR+LF line endings are handled properly.
- Do not go to non-existent buffer index when loading session.
- Do not attempt to open non-existent files when double-clicking error messages.

Updates:

- Look for `~/.ta_theme` for setting Textadept `_THEME`.
- `_THEME` can now be a directory path.
- Themes now contain their own `lexer.lua` for defining lexer colors.
- Added “Find in Files” support.
- Can set the Project Manager cursor through Lua.
- Look for `~/.ta_modules` to load instead of default modules in `init.lua`.
- Added “Replace All” for just selected text.
- Removed menu label text in favor of using menu id numbers for menu actions.
- Added Find/Replace history.
- Use a combo entry for the Project Manager browser entry.
- Print messages to a split view instead of switching buffers.

## 1.2 (21 Jan 2009)

Download:

- Textadept 1.2 – Win32
- Textadept 1.2 – Mac OSX Intel 10.5+
- Textadept 1.2 – Linux

Bugfixes:

- None.

Updates:

- Windows command line support (“Open With Textadept” works too).
- New `_m.textadept.run` module for compiling and running programs. Output is displayed in a message buffer and you can double-click errors and warnings to go to them in the source file.

## 1.1 (11 Jan 2009)

Download:

- Textadept 1.1 – Win32
- Textadept 1.1 – Mac OSX Intel 10.5+
- Textadept 1.1 – Linux

Bugfixes:

- Fixed `core/ext/key_commands_std.lua` key conflict (`Ctrl+V`).

Updates:

- Dramatic speed increase in lexing for large, single-language files.
- Added localization support.
- Added bookmarks support.
- All `require` statements have been moved to `init.lua` for easy module configuration.
- Various improvements to efficiency, speed, and readability of source code.
- Manually parse `~/.gtkrc-2.0` on Mac since GTK-OSX does not do it.

## 1.0 (01 Jan 2009)

Download:

- Textadept 1.0 – Win32
- Textadept 1.0 – Mac OSX Intel 10.5+
- Textadept 1.0 – Linux

Bugfixes:

- Fixed bug with placeholders in Lua-style snippets.
- Fixed view grow/shrink error thrown when the view is not split.
- Various fixes to recognize windows directory separators.
- Fixed some Find bugs.
- Fixed macro recording and playback bugs.

Updates:

- Added actions for all menu items.
- Added Lua interface functions and fields for the find box.
- Nearly full Mac OSX support with GTK-OSX.
- Compile LPeg and LuaFileSystem libraries into Textadept by default.
- Use UTF-8 encoding by default.
- Added `light` color theme used by default.
- New Textadept icons.
- Added a true project manager.

## 0.6 (03 Oct 2008)

Download:

- Textadept 0.6 – Win32
- Textadept 0.6 – Linux
- Textadept 0.6 – Linux x86_64

Bugfixes:

- Gracefully exit when `core/init.lua` fails to load.

Updates:

- Windows support! (finally)
- Theming support (SciTE theme used by default).
- Added `textadept.size` field and save it in session files.
- Some C++ API-simplifying changes.
- Drag-and-drop files into Textadept works as expected.
- Revised manual.
- Buffer and View properties are no longer set in C++, but in Lua through “buffer_new” and “view_new” event handlers respectively.
- File types can be recognized by pattern matching the first line.

## 0.5 (23 Jul 2008)

Download:

- Textadept 0.5 – Linux
- Textadept 0.5 – Linux x86_64

Bugfixes:

- Fixed bug in Lua module when there is no matching file to go to.

Updates:

- Added user-friendly key commands and menus.
- Added 43 more lexers.
- Moved block-comment commands from language modules to `textadept.editing` module.
- Updated some Luadoc.

## 0.4 (25 Jun 2008)

Download:

- Textadept 0.4 – Mac OSX Intel 10.5+
- Textadept 0.4 – Linux
- Textadept 0.4 – Linux x86_64

Bugfixes:

- Fixed bug with “%” being contained in text to replace.
- Fixed compile warnings.
- Fixed bug for menu actions on non-focused buffer.

Updates:

- Added bookmark support through `modules/textadept/bookmarks.lua` (not loaded by default).
- Added icons to Textadept.
- Added a modules browser for adding, deleting, and editing modules easily.
- Consolidated source files into `textadept.c`, `textadept.h`, and `lua_interface.c`.
- Always load project manager settings from session file if available.
- Include `liblua5.1.a` for compiling Lua into Textadept.
- Added true tab-completion to Lua command entry.
- Added Doxygen documentation for C source files.
- Updated Luadoc, and added Textadept manual.

## 0.3 (04 Mar 2008)

Download:

- Textadept 0.3 – Linux

Bugfixes:

- Fixed bug in editing module’s `select_indented_block()`.
- Fixed empty `buffer.filename` bug in `textadept.io.save_as()`.
- Fixed setting of Ruby lexer after detecting filetype.

Updates:

- Makefile builds Textadept to optimize for small size.
- Lua is no longer an external dependency and built into Textadept.
- Zenity is no longer a dependency on Linux. lua_dialog is used instead.
- Resources from `io.popen()` are handled more appropriately.
- Added `textadept.reset()` function for for reloading Lua scripts.
- Added new find in files project manager browser.
- Fixed some code redundancy and typos in documentation.

## 0.2 (20 Dec 2007)

Download:

- Textadept 0.2 – Mac OSX Intel 10.5+
- Textadept 0.2 – Linux

Bugfixes:

- Fixed command line parameters bug.
- Fixed `package.path` precedence bug.
- Use 8 style bits by default.

Updates:

- Scintilla-st.
- Lexers.
- Improved support for embedded language-specific snippets.

## 0.1 (01 Dec 2007)

Download:

- Textadept 0.1 – Mac OSX Intel 10.5+
- Textadept 0.1 – Linux

Initial Release